/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;

public class TextoDemorado {
	private final static Color colorNoValido = Display.getCurrent().getSystemColor(SWT.COLOR_RED);
	private final static Integer retardo = 1500;
	private static Vector<Text> ctrlesText = new Vector<Text>();
	private static Vector<TextoDemorado> textoDemorados = new Vector<TextoDemorado>();
	public static boolean activo=false;
	public static String sqlId1 = null;
	public static String sqlId2 = null;
	public static TextoDemorado clase=null;
	public Text ctrl=null;
	public boolean numero=false;
	public Integer longitud=null;
	public Integer decimales=null;
	public Double maximo=null;
	public boolean vacio=true;
	private Color color=null;
	public static void solicitaSqlModificacion(Text control,String id1,String id2){
		TextoDemorado.clase=textoDemorados.get(ctrlesText.indexOf(control));
		TextoDemorado.sqlId1=id1;
		TextoDemorado.sqlId2=id2;
		TextoDemorado.activo=true;
		//System.out.println("Solicita demorado: "+control.handle+" | "+sql);
	}
	public static Runnable ejecutaSqlModificacion = new Runnable() {
		public void run() {
			if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("...");
			PCuaderno.MiPCuaderno.display.timerExec(-1, ejecutaSqlModificacion);
			TextoDemorado.activo=false;
			if (valido(TextoDemorado.clase.ctrl)) BBDD.ejecutaSqlUpdateTextDemorado();
        }
    };
    public static void escribeSiHay(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("si ("+TextoDemorado.activo+")...");
		if (TextoDemorado.activo) {
			PCuaderno.MiPCuaderno.display.timerExec(-1, TextoDemorado.ejecutaSqlModificacion);
			if (valido(TextoDemorado.clase.ctrl)) BBDD.ejecutaSqlUpdateTextDemorado();
		}
    }
    public static void modificaSinActualizar(Text ctrl,String texto){
    	ctrl.setEnabled(false);ctrl.setText(texto);ctrl.setEnabled(true);
		TextoDemorado textoDemorado=textoDemorados.get(ctrlesText.indexOf(ctrl));
		if (valido(ctrl)) ctrl.setForeground(textoDemorado.color);
		else ctrl.setForeground(TextoDemorado.colorNoValido);
    }
    public static boolean valido(Text ctrl){
    	if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(Text="+ctrl.getText()+")");
    	boolean valido=false;
    	if (ctrl!=null) {
    		String texto=ctrl.getText();
	    	TextoDemorado textoDemorado = textoDemorados.get(TextoDemorado.ctrlesText.indexOf(ctrl));
			//System.out.println("numero="+textoDemorado.numero+" decimal="+textoDemorado.decimales+" longitud="+textoDemorado.longitud+" maximo="+textoDemorado.maximo+" vacio="+textoDemorado.vacio);
			if (textoDemorado.numero){
				if (textoDemorado.decimales!=null) {
					if (textoDemorado.decimales==0) {
						if (textoDemorado.longitud!=null) if (texto.length()>textoDemorado.longitud) {
						} else {
							if (Numero.validarNumeroEntero(texto,textoDemorado.maximo,textoDemorado.vacio)!=null) valido=true;
						}
					} else {
						if (Numero.validarNumeroDecimal(texto,textoDemorado.maximo,textoDemorado.vacio)!=null) valido=true;
					}
				} else {
					if (textoDemorado.longitud!=null) if (texto.length()>textoDemorado.longitud) {
					} else {
						if (Numero.validarNumeroEntero(texto,textoDemorado.maximo,textoDemorado.vacio)!=null) valido=true;
					}
				}
			} else {
				if (textoDemorado.longitud!=null) if (texto.length()>textoDemorado.longitud) {
				} else {
					if (!textoDemorado.vacio && texto.isEmpty()) {}
					else valido=true;
				}
			}
		}
    	if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(Text="+ctrl.getText()+") => "+valido);
		return valido;
    }
	public static void add(final Text ctrlTexto,boolean numero,Integer longitud,Integer decimales,Double maximo,boolean vacio,final ListConId listConId1,final ListConId listConId2){
		TextoDemorado.ctrlesText.add(ctrlTexto);
		TextoDemorado nuevo = new TextoDemorado();
		nuevo.numero=numero;
		nuevo.longitud=longitud;
		nuevo.decimales=decimales;
		nuevo.ctrl=ctrlTexto;
		nuevo.maximo=maximo;
		nuevo.vacio=vacio;
		//System.out.println("TextoDemorado add Color="+ctrlTexto.getBackground().toString());
		nuevo.color=ctrlTexto.getForeground();
		TextoDemorado.textoDemorados.add(nuevo);
		ctrlTexto.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			TextoDemorado textoDemorado = TextoDemorado.textoDemorados.get(TextoDemorado.ctrlesText.indexOf(ctrlTexto));
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				if (ctrlTexto.getEnabled()){
					if (valido(ctrlTexto)){
						ctrlTexto.setForeground(textoDemorado.color);
						solicitaSqlModificacion(ctrlTexto,(listConId1!=null)?listConId1.idSeleccionado():null,(listConId2!=null)?listConId2.idSeleccionado():null);
						PCuaderno.MiPCuaderno.display.timerExec(-1, TextoDemorado.ejecutaSqlModificacion);
						PCuaderno.MiPCuaderno.display.timerExec(TextoDemorado.retardo, TextoDemorado.ejecutaSqlModificacion);
					} else {
						ctrlTexto.setForeground(TextoDemorado.colorNoValido);
					}
				}
			}
		});
		ctrlTexto.addFocusListener(new org.eclipse.swt.events.FocusAdapter() {
			public void focusLost(org.eclipse.swt.events.FocusEvent e) {
				if (TextoDemorado.activo) {
					PCuaderno.MiPCuaderno.display.timerExec(-1, TextoDemorado.ejecutaSqlModificacion);
					TextoDemorado.activo=false;
					if (valido(ctrlTexto)) BBDD.ejecutaSqlUpdateTextDemorado();
				}
			}
		});
	}
	public static void add(final Text ctrlTexto,boolean numero,Integer longitud,Integer decimales,Double maximo,boolean vacio,final TreeConId arbol,final ComboConId combo){
		TextoDemorado.ctrlesText.add(ctrlTexto);
		TextoDemorado nuevo = new TextoDemorado();
		nuevo.numero=numero;
		nuevo.longitud=longitud;
		nuevo.decimales=decimales;
		nuevo.ctrl=ctrlTexto;
		nuevo.maximo=maximo;
		nuevo.vacio=vacio;
		//System.out.println("TextoDemorado add Color="+ctrlTexto.getBackground().toString());
		nuevo.color=ctrlTexto.getForeground();
		TextoDemorado.textoDemorados.add(nuevo);
		ctrlTexto.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			TextoDemorado textoDemorado = TextoDemorado.textoDemorados.get(TextoDemorado.ctrlesText.indexOf(ctrlTexto));
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				if (ctrlTexto.getEnabled()){
					if (valido(ctrlTexto)){
						ctrlTexto.setForeground(textoDemorado.color);
						solicitaSqlModificacion(ctrlTexto,(arbol!=null)?arbol.getIdSeleccionado():null,(combo!=null)?combo.idSeleccionado():null);
						PCuaderno.MiPCuaderno.display.timerExec(-1, TextoDemorado.ejecutaSqlModificacion);
						PCuaderno.MiPCuaderno.display.timerExec(TextoDemorado.retardo, TextoDemorado.ejecutaSqlModificacion);
					} else {
						ctrlTexto.setForeground(TextoDemorado.colorNoValido);
					}
				}
			}
		});
		ctrlTexto.addFocusListener(new org.eclipse.swt.events.FocusAdapter() {
			public void focusLost(org.eclipse.swt.events.FocusEvent e) {
				if (TextoDemorado.activo) {
					PCuaderno.MiPCuaderno.display.timerExec(-1, TextoDemorado.ejecutaSqlModificacion);
					TextoDemorado.activo=false;
					if (valido(ctrlTexto)) BBDD.ejecutaSqlUpdateTextDemorado();
					//System.out.println(ctrlTexto.handle+" - Perdiendo foco: Fijando demorados...");
				}
			}
		});
	}
}